program CalcToBIN;

uses crt,strings,dos;

const
	ERR_FILENOTFOUND = 1;
	ERR_USAGE = 2;

var
	ParamName:string[8];
	ConvertType:array[0..4] of char;
	Source,Dest,Temp:file of byte;
	Name:string[12];
	Extension:string[4];
	Size:integer;
	OutName:string[12];


procedure FileNotFound;
begin
	textcolor(Red);
	writeln('The file ',Name,' was not found in this directory!');
	textcolor(LightGray);
	writeln;
	halt(ERR_FILENOTFOUND);
end;

procedure Usage;
begin
	textcolor(Yellow);
	writeln('USAGE: 8_ptobin filename -xx [outfile]');
	writeln('xx: 83  = TI-83 (.83p)');
	writeln('    83p = TI-83+ (.8xp)');
	writeln('    86  = TI-86 (.86p)');
	writeln('[outfile] = Name of output file (without extension)');
	writeln('If not specified, the original filename with a .bin extension will be used.');
	textcolor(LightGray);
	writeln;
	halt(ERR_USAGE);
end;

procedure Intro;
begin
	writeln;
	textcolor(LightCyan);
	writeln('8?P -> BIN CONVERTER v3.0');
	textcolor(Cyan);
	writeln('Copyright (c)2000-2001 Ti-Calculator Programming Alliance');
	writeln('Written and Programmed by James Vernon <james@calc.org>');
	writeln('http://tcpa.calc.org');
	writeln('ICQ#: 71589304');
	textcolor(LightGray);
	writeln;
	writeln;
end;

procedure GetFile;
begin
	ParamName:=paramstr(1);
	strpcopy(ConvertType,paramstr(2));
	if (strcomp(ConvertType,'-83')=0) then
	begin
		Extension:='.83p';
		Size:=74;
	end
	else if (strcomp(ConvertType,'-83p')=0) then
	begin
		Extension:='.8xp';
		Size:=76;
	end
	else if (strcomp(ConvertType,'-83P')=0) then
	begin
		Extension:='.8xp';
		Size:=76;
	end
	else if (strcomp(ConvertType,'-86')=0) then
	begin
		Extension:='.86p';
		Size:=77;
	end
	else Usage;
	Name:=ParamName+Extension;
	assign(Source,Name);
	{$I-}
	reset(Source);
	{$I+}
	if IOResult <> 0 then FileNotFound;
end;

procedure IniFiles;
begin
	if (paramcount = 2) then OutName:=ParamName+'.bin'
	else OutName:=paramstr(3)+'.bin';
	assign(Dest,OutName);
	rewrite(Dest);
	assign(Temp,'8_ptobin.tmp');
	rewrite(Temp);
end;

procedure ConvertFile;
var
	FileLength,Count:integer;
	Data:byte;
begin
	write('Converting...');
	FileLength:=0;
	repeat
		read(Source,Data);
		inc(FileLength);
	until eof(Source);
	FileLength:=FileLength-Size;
	reset(Source);
	for Count:=1 to (Size-2) do read(Source,Data);
	repeat
		read(Source,Data);
		write(Temp,Data);
	until eof(Source);
	reset(Temp);
	for Count:=1 to FileLength do begin
		read(Temp,Data);
		write(Dest,Data);
	end;
	close(Source);
	close(Dest);
	close(Temp);
	erase(Temp);
	writeln(' Done!');
	writeln;
	writeln('Output file: ',OutName);
	writeln;
end;

begin
	Intro;
	if ((paramcount < 2) or (paramcount > 3)) then Usage;
	GetFile;
	IniFiles;
	ConvertFile;
end.